<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>2.1 Types</title>
<link href="sx2.html" rev=precedes>
<link href="sx2b.html" rel=precedes>
<link href="sx2.html" rev=subdocument>
</head>
<body>
<H2>2.1 Types</H2>

<p>[This section corresponds to K&amp;R Sec. 2.2]
</p><p>There are only a few basic data types in C.
The first ones we'll be
encountering and
using are:

<UL><li><csyntax>char</>
a character
<li><csyntax>int</>
an integer, in the range -32,767 to 32,767
<li><csyntax>long int</>
a larger integer
(up to +-2,147,483,647)
<li><csyntax>float</>
a floating-point number
<li><csyntax>double</>
a floating-point number,
with more precision and perhaps greater range than <TT>float</TT>
</UL></p><p>If you can look at this list of
basic types
and say to yourself,
``Oh, how simple, there are only a few types,
I won't have to worry much about choosing among them,''
you'll have an easy time with declarations.
(Some masochists

wish that the type system were more complicated
so that they could specify more things about each variable,
but those of us who would rather not have to specify these
extra things each time are glad that we don't have to.)
</p><p>The ranges listed above for types <TT>int</TT> and
<TT>long int</TT> are the guaranteed minimum ranges.
On some systems, either of these types
(or, indeed, any C type)
may be able to hold larger values,
but a program that depends on
extended ranges
will not be as portable.
Some programmers

become obsessed with knowing exactly what
the sizes of data objects will be in various situations,
and go on to write programs which depend on these exact sizes.
Determining or controlling the size of an object is
occasionally important,
but most of the time we can sidestep size issues
and let the compiler do most of the worrying.
</p><p>(From the ranges listed above,
we can determine that
type <TT>int</TT> must be at least 16 bits,
and that type <TT>long int</TT> must be at least 32 bits.
But neither of these sizes is exact;
many systens have 32-bit <TT>int</TT>s,
and some systems have 64-bit <TT>long int</TT>s.)
</p><p>You might wonder how the computer stores characters.
The answer involves a <dfn>character set</dfn>,
which is simply a mapping between some set of characters
and some set of small numeric codes.
Most machines today use the ASCII character set,
in which the letter A is represented by the code 65,
the ampersand &amp; is represented by the code 38,
the digit 1 is represented by the code 49,
the space character is represented by the code 32,
etc.
(Most of the time,
of course,
you have <em>no</em> need to know or even worry about
these particular code values;
they're automatically translated into
the right shapes on the screen or printer when characters are printed out,
and they're automatically generated
when you type characters on the keyboard.
Eventually, though,
we'll appreciate,
and even take some control over,
exactly when these translations--from
characters to their numeric codes--are
performed.)
Character codes are usually small--the
largest code value in ASCII is 126,
which is the ~ (tilde or circumflex) character.
Characters usually fit in a byte, which is usually 8 bits.
In C, type <TT>char</TT> is defined as occupying one byte,
so it is usually 8 bits.
</p><p>Most of the simple variables in most programs are of types 
<TT>int</TT>, <TT>long int</TT>, or <TT>double</TT>.
Typically, we'll use <TT>int</TT> and <TT>double</TT> for most 
purposes, and <TT>long int</TT> any time we need to hold integer values 
greater than 32,767.
As we'll see,
even when we're manipulating individual characters,
we'll usually use an <TT>int</TT> variable,
for
reasons to be discussed later.
Therefore,
we'll
rarely use individual variables of type <TT>char</TT>;
although we'll use plenty of arrays of <TT>char</TT>.
</p><hr>
<p>
Read sequentially:
<a href="sx2.html" rev=precedes>prev</a>
<a href="sx2b.html" rel=precedes>next</a>
<a href="sx2.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-1997
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
